#pragma once

const int motor_L1 = 15;
const int motor_L2 = 14;

const int motor_R1 = 13;
const int motor_R2 = 12;


const int L1_pwm_chanel = 3;
const int L2_pwm_chanel = 4;

const int R1_pwm_chanel = 5;
const int R2_pwm_chanel = 6;

int  global_leftPwm=0; 
int  global_RightPwm=0;

const int Resolution = 8;
int Max_power = 255;

void init_motors()
{
  pinMode(motor_L1, OUTPUT);
  pinMode(motor_L2, OUTPUT);
  pinMode(motor_R1, OUTPUT);
  pinMode(motor_R2, OUTPUT);

  ledcSetup(L1_pwm_chanel, 500, Resolution);
  ledcAttachPin(motor_L1, L1_pwm_chanel);
  ledcSetup(L2_pwm_chanel, 500, Resolution);
  ledcAttachPin(motor_L2, L2_pwm_chanel);

  ledcSetup(R1_pwm_chanel, 500, Resolution);
  ledcAttachPin(motor_R1, R1_pwm_chanel);
  ledcSetup(R2_pwm_chanel, 500, Resolution);
  ledcAttachPin(motor_R2, R2_pwm_chanel);

  ledcWrite(L1_pwm_chanel, 0);
  ledcWrite(L2_pwm_chanel, 0);
  ledcWrite(R1_pwm_chanel, 0);
  ledcWrite(R2_pwm_chanel, 0);
}



void forward(int leftPwm, int RightPwm)
{
  global_leftPwm = constrain(leftPwm, -Max_power, Max_power);
  global_RightPwm = constrain(RightPwm, -Max_power, Max_power);
  if (leftPwm >= 0)
  {
    ledcWrite(L1_pwm_chanel, 0);
    ledcWrite(L2_pwm_chanel, leftPwm);
  }
  else
  {
    ledcWrite(L2_pwm_chanel, 0);
    ledcWrite(L1_pwm_chanel, -leftPwm);
  }

  if (RightPwm >= 0)
  {
    ledcWrite(R1_pwm_chanel, 0);
    ledcWrite(R2_pwm_chanel, RightPwm);
  }
  else
  {
    ledcWrite(R2_pwm_chanel, 0);
    ledcWrite(R1_pwm_chanel, -RightPwm);
  }
}
